!{\src2tex{textfont=tt}}
!!****f* ABINIT/defs_berry
!!
!! NAME
!! defs_berry
!!
!! FUNCTION
!!
!! COPYRIGHT
!! Copyright (C) 2009 ABINIT group ()
!! This file is distributed under the terms of the
!! GNU General Public License, see ~abinit/COPYING
!! or http://www.gnu.org/copyleft/gpl.txt .
!! For the initials of contributors, see ~abinit/doc/developers/contributors.txt .
!!
!! INPUTS
!!
!! OUTPUT
!!
!! PARENTS
!!
!! CHILDREN
!!
!! SOURCE

#if defined HAVE_CONFIG_H
#include "config.h"
#endif

module defs_berry

 use defs_basis

 implicit none

 interface
  subroutine initberry(dtefield,dtfil,dtset,gmet,kg,mband,mkmem,mpi_enreg,&  
&  mpw,nkpt,npwarr,nsppol,nsym,occ,pwind,pwind_alloc,pwnsfac,&  
&  rprimd,symrec)
   use defs_basis
   use defs_datatypes
   integer,intent(in) :: mband
   integer,intent(in) :: mkmem
   integer,intent(in) :: mpw
   integer,intent(in) :: nkpt
   integer,intent(in) :: nsppol
   integer,intent(in) :: nsym
   integer,intent(out) :: pwind_alloc
   type(efield_type),intent(out) :: dtefield
   type(datafiles_type),intent(in) :: dtfil
   type(dataset_type),intent(inout) :: dtset
   type(MPI_type),intent(inout) :: mpi_enreg
   real(dp),intent(in) :: gmet(3,3)
   integer,intent(in) :: kg(3,mpw*mkmem)
   integer,intent(in) :: npwarr(nkpt)
   real(dp),intent(in) :: occ(mband*nkpt*nsppol)
   integer,pointer :: pwind(:,:,:)
   real(dp),pointer :: pwnsfac(:,:)
   real(dp),intent(in) :: rprimd(3,3)
   integer,intent(in) :: symrec(3,3,nsym)
  end subroutine initberry
 end interface

end module defs_berry
!!***
